package xyz.lychee.lagfixer.libs.examination;

import java.util.stream.Stream;
import xyz.lychee.lagfixer.libs.annotations.NotNull;

public interface Examinable {
   default @NotNull String examinableName() {
      return this.getClass().getSimpleName();
   }

   default @NotNull Stream<? extends ExaminableProperty> examinableProperties() {
      return Stream.empty();
   }

   default <R> @NotNull R examine(final @NotNull Examiner<R> examiner) {
      return examiner.examine(this);
   }
}
